#!/bin/ksh
checkitout0_sh='for ((i=0; i<10; i++)); do for ((j=0; j<64; j++)); do printf "_"; done; printf "%d\n" $i; sleep 1; done' 
checkitout1_sh='for ((i=0; i<10; i++)); do printf "%d\n" $i; for ((j=0; j<64; j++)); do printf "_"; done; sleep 1; done' 
check00(){
  printf "00.testing $1:	"
  printf "" > out.txt
  ./"$@" out.txt > out-$1.txt & pid=$! && sleep 2
  ksh -c "$checkitout0_sh" >> out.txt &
  sleep 15 && kill -9 $pid
  case "$1" in
  tail-f)
    diff out.txt out-$1.txt
    ;;
  *)
    grep '[0124689]' out.txt | diff - out-$1.txt
    ;;
  esac &&
  { echo success; rm out*.txt; } || { echo failure; exit 1; }
}
check01(){
  printf "01.testing $1:	"
  printf "" > out.txt
  ./"$@" out.txt > out-$1.txt & pid=$! && sleep 2
  ksh -c "$checkitout1_sh" >> out.txt &
  sleep 15 && kill -9 $pid
  case "$1" in
  tail-f)
    head -n 10 out.txt | diff - out-$1.txt
    ;;
  *)
    head -n 10 out.txt | grep '[0124689]' | diff - out-$1.txt
    ;;
  esac &&
  { echo success; rm out*.txt; } || { echo failure; exit 1; }
}
check10(){
  printf "10.testing $1:	"
  printf "" > out.txt
  ksh -c "$checkitout0_sh" >> out.txt & sleep 1
  ./"$@" out.txt > out-$1.txt & pid=$!
  sleep 15 && kill -9 $pid
  case "$1" in
  tail-f)
    tail -n 8 out.txt | diff - out-$1.txt
    ;;
  *)
    tail -n 8 out.txt | grep '[0124689]' | diff - out-$1.txt
    ;;
  esac &&
  { echo success; rm out*.txt; } || { echo failure; exit 1; }
}
check11(){
  printf "11.testing $1:	"
  printf "" > out.txt
  ksh -c "$checkitout1_sh" >> out.txt & sleep 1
  ./"$@" out.txt > out-$1.txt & pid=$!
  sleep 15 && kill -9 $pid
  case "$1" in
  tail-f)
    head -n 10 out.txt | tail -n 8 | diff - out-$1.txt
    ;;
  *)
    head -n 10 out.txt | tail -n 8 | grep '[0124689]' | diff - out-$1.txt
    ;;
  esac &&
  { echo success; rm out*.txt; } || { echo failure; exit 1; }
}

: && {
  for c in 00 01 10 11; do
    check$c tail-f -w 2 -n 0
  done
}
: && {
  for c in 00 01 10 11; do
    check$c tail-f-grep -w 2 -n 0 '[0124689]'
  done
}
: && {
  for c in 00 01 10 11; do
    check$c logdoes -w 2 -s cat '[0124689]'
  done
}
: && {
  for c in 00 01 10 11; do
    check$c logsdo -w 2 -s cat '[0124689]'
  done
}
: && {
  for c in 00 01 10 11; do
    check$c logdo -w 2 -s cat '[0124689]'
  done
}
